/*------------------------------------------------------------------------------
--  This file is a part of the libuc, microcontroler library
--  Copyright (C) 2012, Alexis Jeandet
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------
--                 Author : Alexis Jeandet
--                   Mail : alexis.jeandet@gmail.com
-------------------------------------------------------------------------------*/
#ifndef TERMINAL_H
#define TERMINAL_H
#include <stdint.h>
#include <widget.h>
#include <streamdevices.h>
#include <genericLCD_Controler.h>
#include <fonts.h>

typedef struct terminal_t
{
    uint16_t line;
    uint16_t column;
    uint16_t lineCount;
    uint16_t columnCount;
    uint16_t firstLine;
    uint16_t lastLine;
    uint16_t Xpos;
    uint16_t Ypos;
    uint16_t width;
    uint16_t height;
    uint32_t backgroundColor;
    uint32_t textColor;
    int8_t verticalSpace;
    int8_t horizontalSpace;
    int8_t empty;
    LCD_t* LCD;
    sFONT* font;
    char* buffer;
}terminal_t;

int terminal_init(terminal_t* terminal,LCD_t* LCD,sFONT* font,streamdevice* strdev);
void terminal_setgeometry(terminal_t* terminal,uint16_t Xpos,uint16_t Ypos,uint16_t width,uint16_t height);
void terminal_clear(terminal_t* terminal);
void terminal_setbackgroundColor(terminal_t* terminal, uint32_t backgrooundColor);
void terminal_settextColor(terminal_t* terminal, uint32_t textColor);
void terminal_movecursor(terminal_t* terminal,int n);
void terminal_clearCurentLine(terminal_t* terminal);
int terminal_write(streamdevice* device,void* data,int size, int n);
int terminal_read(streamdevice* device,void* data,int size, int n);
int terminal_setpos(streamdevice* device,int pos);
int terminal_close(streamdevice* device);









#endif
